#########################
# Definition des couleurs
#########################

# Note : Les couleurs sont moches ? Changez-les !

### Problemes
# mettre les _clon _cloff _nobold, etc.. dans l'aide.
# Les couleurs ne marchent pas ni dans la barre de statut, ni dans le prompt

# Les couleurs sont definis selon mIRC
# Un ^C suivi de la couleur de premier plan, une virgule,
# puis la couleur de fond. On termine par ^Q
# Attention a mettre 2 chiffres par couleur ('01' et non '1') sinon ca bug
# ne marche qu'avec ircII 4.4

alias _clon {
^set color on
# In order not to screw up the display
^set mangle_inbound BOLD,COLOR,REVERSE,UNDERLINE,BLINK
# Gras
@BLD=[]
# Video inverse
@IVT=[]
# Souligne
@UDL=[]
# Couleur
@COL=[]
# Fin de couleur
@RST=[]
#----------
# Couleurs
@WHT=00;@BLK=01;@DBLU=02;@GRN=03;@RED=04;@BRN=05;@IDG=06;@ORG=05;@YEL=05;@LGRN=03;@TQS=10;@CYA=10;@BLU=12;@PRL=13;@GRA=14;@LGRA=15;@BYEL=08;@BRED=07;@BCYA=11
^assign color ON
#end of _clon
}


# Change juste la couleur de premier plan.
alias _c {
	if ([$COL]) {
		^assign FUNCTION_RETURN $COL$0$1-
	} {
# We must suppress the first argument and the space
		^assign FUNCTION_RETURN $mid(1 1000 $0-)
	}
}

# Change la couleur de premier plan et la couleur de fond.
alias _cc {
	if ([$COL]) {
		^assign FUNCTION_RETURN $COL$0,$1$2-
	} {
# We must suppress the first argument and the space
		^assign FUNCTION_RETURN $mid(2 1000 $0-)
	}
}

#-------------------------------------------------------------------#
# Couleurs a choisir                                                #
# Changer ce qui suit pour modifier l'apparence colorifique d'ircII #
#-------------------------------------------------------------------#

#-- general

# Le <nick> des autres
alias cnickk {^assign FUNCTION_RETURN $_c($LGRA <)$_c($CYA $0-)$_c($LGRA >)$RST}

# Le mien, et la couleur de ce que je dis
alias cnickm {^assign FUNCTION_RETURN $_c($CYA <)$_c($GRN $0)$_c($CYA >) $_c($TQS $1-)}

# Channel names
alias cchan {
  ^assign FUNCTION_RETURN $_c($LGRN $sar(g/\@/$_c($BRED \@)$RST$_c($LGRN)/$0-))$RST
}

# Nicks
alias cnick {
  ^assign FUNCTION_RETURN $_c($CYA $sar(g/\@/$_c($BRED \@)$RST$_c($CYA)/$0-))$RST
}

# Les topics
alias ctopic {^assign FUNCTION_RETURN \"$_c($YEL $0-)$RST\"}

# Les noms de serveur
alias cserv {^assign FUNCTION_RETURN $_c($ORG $0-)$RST}

# Les noms de commande
alias ccmd {^assign FUNCTION_RETURN $_c($RED $0-)$RST}

# Modes
alias cmod {^assign FUNCTION_RETURN $_c($BRED $0-)$RST}

# IRCOP
alias circop {^assign FUNCTION_RETURN $_cc($WHT $BRED $0-)$RST}

# Raisons (de quit, d'away...)
alias creason {^assign FUNCTION_RETURN $_c($GRN \($0-\))$RST}

# Heures et dates
alias ctime {^assign FUNCTION_RETURN $_c($YEL $0-)$RST}

# Versions
alias cver {^assign FUNCTION_RETURN $BLD$0-$BLD}

# User @ host
alias cusr {^assign FUNCTION_RETURN $_c($YEL $loginonly($0-))$RST@$_c($RED $addronly($0-))$RST}

#-- messages particuliers

# Messages prives recus
alias c_rmsg {^assign FUNCTION_RETURN $_cc($BLK $CYA [$0])$RST $_c($BYEL $1-)}

# Messages publics recus avec beep
alias c_pub_beep {^assign FUNCTION_RETURN $_c($BYEL <)$_c($BRED $0)$RST$_c($BYEL > $1-)}

# Actions publiques recues avec beep
alias c_act_beep {^assign FUNCTION_RETURN $_c($BCYA *)$RST $_c($BYEL $0) $_c($BYEL $1-)}

# Actions recues
alias c_act {^assign FUNCTION_RETURN $_c($CYA *) $cnick($0) $1-}

# Actions envoyees
alias c_sact {^assign FUNCTION_RETURN $_c($CYA *) $_c($GRN $0) $_c($CYA $1-)}

# Notices recues
alias c_rnotice {^assign FUNCTION_RETURN $_c($YEL -$0)\-$RST $1-}

# DCC recus
alias c_rdcc {^assign FUNCTION_RETURN $_c($BYEL =$0=)$RST $_c($YEL $1-)}

# messages envoyes
alias c_smsg {^assign FUNCTION_RETURN $_c($BCYA ->$0)$RST $_c($CYA $1-)}

# notices envoyees
alias c_snotice {^assign FUNCTION_RETURN $_c($YEL ->)$cnick($0)$_c($YEL -)$RST $1-}

# DCC envoyes
alias c_sdcc {^assign FUNCTION_RETURN $_c($YEL =>)$RST$_c($BYEL $0)$RST $_c($CYA $1-)}

# Modes change
alias c_mode {
	if ([$1] == [$N]) {
		^assign msg_mod $_c($RED ***)$RST Mode change $cmod($2-) for user $cnick($1) by $cnick($0)
	} {
		^assign msg_mod $_c($RED ***)$RST Mode change $cmod($2-) on channel $cchan($1) by $cnick($0)
	}
	techo $msg_mod
}


# Erreurs
alias cecho1 {
	techo $_cc($WHT $RED ***)$RST $0-
}
# Info
alias cecho2 {
	techo $_c($DBLU ***)$RST $0-
}
# Erreur diverses
alias cecho9 {
	techo $_c($DBLU ***)$RST $0-
}
# messages IRCOP
alias cecho8 {
	techo $_cc($BRED $WHT ***)$RST $0-
}
# Script messages
alias cecho3 {
	techo $_c($IDG ***)$RST $0-
}
# Welcome and MOTD message
alias cecho4 {
	techo $_c($CYA ***)$RST $0-
}

alias _cloff {@BLD=[];@IVT=[];@COL=[];@RST=[];@RED=[];@GRN=[];@YEL=[];@BLU=[];@ORG=[];@CYA=[];@WHT=[];@DBLU=[];@BLK=[];@BRN=[];@IDG=[];@LGRN=[];@TQS=[];@PRL=[];@GRA=[];@LGRA=[];@BYEL=[];@BRED=[];@BCYA=[]
^assign color OFF
^set color OFF
^set -mangle_inbound
}

alias _nobold {@BLD=[]}
alias _noinvert {@IVT=[]}
alias _nounderline {@UDL=[]}

alias _bold {@BLD=[]}
alias _invert {@IVT=[]}
alias _underline {@UDL=[]}

_bold
